diff --git a/TAGS b/TAGS
index 40e1640..c22cb0d 100644
--- a/TAGS
+++ b/TAGS
@@ -184,257 +2447,263 @@ impl<'a> Widget for ImportWizardWidget<'a> {ImportWizardWidget21,444
     fn render(self, area: Rect, buf: &mut Buffer) {render22,489
 fn truncate(s: &str, max: usize) -> String {truncate339,13390
 
-src/ui/effect.rs,13895
-pub trait Effect: Debug {Effect11,253
-    fn apply(&self, app: &mut App);apply12,279
-    fn changes_mode(&self) -> bool {changes_mode14,365
-pub struct AddCategory(pub String);AddCategory22,644
-impl Effect for AddCategory {AddCategory23,680
-    fn apply(&self, app: &mut App) {apply24,710
-pub struct AddItem {AddItem30,822
-    pub category: String,category31,843
-    pub item: String,item32,869
-impl Effect for AddItem {AddItem34,893
-    fn apply(&self, app: &mut App) {apply35,919
-pub struct AddItemInGroup {AddItemInGroup45,1193
-    pub category: String,category46,1221
-    pub item: String,item47,1247
-    pub group: String,group48,1269
-impl Effect for AddItemInGroup {AddItemInGroup50,1294
-    fn apply(&self, app: &mut App) {apply51,1327
-pub struct SetCell(pub CellKey, pub CellValue);SetCell61,1623
-impl Effect for SetCell {SetCell62,1671
-    fn apply(&self, app: &mut App) {apply63,1697
-pub struct ClearCell(pub CellKey);ClearCell69,1820
-impl Effect for ClearCell {ClearCell70,1855
-    fn apply(&self, app: &mut App) {apply71,1883
-pub struct AddFormula {AddFormula77,1985
-    pub raw: String,raw78,2009
-    pub target_category: String,target_category79,2030
-impl Effect for AddFormula {AddFormula81,2065
-    fn apply(&self, app: &mut App) {apply82,2094
-pub struct RemoveFormula {RemoveFormula102,2878
-    pub target: String,target103,2905
-    pub target_category: String,target_category104,2929
-impl Effect for RemoveFormula {RemoveFormula106,2964
-    fn apply(&self, app: &mut App) {apply107,2996
-pub struct EnterEditAtCursor;EnterEditAtCursor116,3269
-impl Effect for EnterEditAtCursor {EnterEditAtCursor117,3299
-    fn apply(&self, app: &mut App) {apply118,3335
-pub struct TogglePruneEmpty;TogglePruneEmpty132,3729
-impl Effect for TogglePruneEmpty {TogglePruneEmpty133,3758
-    fn apply(&self, app: &mut App) {apply134,3793
-pub struct ToggleCatExpand(pub String);ToggleCatExpand141,3941
-impl Effect for ToggleCatExpand {ToggleCatExpand142,3981
-    fn apply(&self, app: &mut App) {apply143,4015
-pub struct RemoveItem {RemoveItem151,4190
-    pub category: String,category152,4214
-    pub item: String,item153,4240
-impl Effect for RemoveItem {RemoveItem155,4264
-    fn apply(&self, app: &mut App) {apply156,4293
-pub struct RemoveCategory(pub String);RemoveCategory162,4415
-impl Effect for RemoveCategory {RemoveCategory163,4454
-    fn apply(&self, app: &mut App) {apply164,4487
-pub struct CreateView(pub String);CreateView172,4798
-impl Effect for CreateView {CreateView173,4833
-    fn apply(&self, app: &mut App) {apply174,4862
-pub struct DeleteView(pub String);DeleteView180,4965
-impl Effect for DeleteView {DeleteView181,5000
-    fn apply(&self, app: &mut App) {apply182,5029
-pub struct SwitchView(pub String);SwitchView188,5140
-impl Effect for SwitchView {SwitchView189,5175
-    fn apply(&self, app: &mut App) {apply190,5204
-pub struct ViewBack;ViewBack202,5577
-impl Effect for ViewBack {ViewBack203,5598
-    fn apply(&self, app: &mut App) {apply204,5625
-pub struct ViewForward;ViewForward215,5991
-impl Effect for ViewForward {ViewForward216,6015
-    fn apply(&self, app: &mut App) {apply217,6045
-pub struct SetAxis {SetAxis227,6331
-    pub category: String,category228,6352
-    pub axis: Axis,axis229,6378
-impl Effect for SetAxis {SetAxis231,6400
-    fn apply(&self, app: &mut App) {apply232,6426
-pub struct SetPageSelection {SetPageSelection240,6588
-    pub category: String,category241,6618
-    pub item: String,item242,6644
-impl Effect for SetPageSelection {SetPageSelection244,6668
-    fn apply(&self, app: &mut App) {apply245,6703
-pub struct ToggleGroup {ToggleGroup253,6876
-    pub category: String,category254,6901
-    pub group: String,group255,6927
-impl Effect for ToggleGroup {ToggleGroup257,6952
-    fn apply(&self, app: &mut App) {apply258,6982
-pub struct HideItem {HideItem266,7159
-    pub category: String,category267,7181
-    pub item: String,item268,7207
-impl Effect for HideItem {HideItem270,7231
-    fn apply(&self, app: &mut App) {apply271,7258
-pub struct ShowItem {ShowItem279,7422
-    pub category: String,category280,7444
-    pub item: String,item281,7470
-impl Effect for ShowItem {ShowItem283,7494
-    fn apply(&self, app: &mut App) {apply284,7521
-pub struct TransposeAxes;TransposeAxes292,7685
-impl Effect for TransposeAxes {TransposeAxes293,7711
-    fn apply(&self, app: &mut App) {apply294,7743
-pub struct CycleAxis(pub String);CycleAxis300,7860
-impl Effect for CycleAxis {CycleAxis301,7894
-    fn apply(&self, app: &mut App) {apply302,7922
-pub struct SetNumberFormat(pub String);SetNumberFormat308,8042
-impl Effect for SetNumberFormat {SetNumberFormat309,8082
-    fn apply(&self, app: &mut App) {apply310,8116
-pub struct SetSelected(pub usize, pub usize);SetSelected318,8459
-impl Effect for SetSelected {SetSelected319,8505
-    fn apply(&self, app: &mut App) {apply320,8535
-pub struct SetRowOffset(pub usize);SetRowOffset326,8663
-impl Effect for SetRowOffset {SetRowOffset327,8699
-    fn apply(&self, app: &mut App) {apply328,8730
-pub struct SetColOffset(pub usize);SetColOffset334,8850
-impl Effect for SetColOffset {SetColOffset335,8886
-    fn apply(&self, app: &mut App) {apply336,8917
-pub struct ChangeMode(pub AppMode);ChangeMode344,9251
-impl Effect for ChangeMode {ChangeMode345,9287
-    fn apply(&self, app: &mut App) {apply346,9316
-    fn changes_mode(&self) -> bool {changes_mode349,9394
-pub struct SetStatus(pub String);SetStatus355,9470
-impl Effect for SetStatus {SetStatus356,9504
-    fn apply(&self, app: &mut App) {apply357,9532
-pub struct MarkDirty;MarkDirty363,9636
-impl Effect for MarkDirty {MarkDirty364,9658
-    fn apply(&self, app: &mut App) {apply365,9686
-pub struct SetYanked(pub Option<CellValue>);SetYanked371,9775
-impl Effect for SetYanked {SetYanked372,9820
-    fn apply(&self, app: &mut App) {apply373,9848
-pub struct SetSearchQuery(pub String);SetSearchQuery379,9948
-impl Effect for SetSearchQuery {SetSearchQuery380,9987
-    fn apply(&self, app: &mut App) {apply381,10020
-pub struct SetSearchMode(pub bool);SetSearchMode387,10126
-impl Effect for SetSearchMode {SetSearchMode388,10162
-    fn apply(&self, app: &mut App) {apply389,10194
-pub struct SetBuffer {SetBuffer396,10326
-    pub name: String,name397,10349
-    pub value: String,value398,10371
-impl Effect for SetBuffer {SetBuffer400,10396
-    fn apply(&self, app: &mut App) {apply401,10424
-pub struct SetTileCatIdx(pub usize);SetTileCatIdx412,10752
-impl Effect for SetTileCatIdx {SetTileCatIdx413,10789
-    fn apply(&self, app: &mut App) {apply414,10821
-pub struct StartDrill(pub Vec<(CellKey, CellValue)>);StartDrill422,11020
-impl Effect for StartDrill {StartDrill423,11074
-    fn apply(&self, app: &mut App) {apply424,11103
-pub struct ApplyAndClearDrill;ApplyAndClearDrill434,11418
-impl Effect for ApplyAndClearDrill {ApplyAndClearDrill435,11449
-    fn apply(&self, app: &mut App) {apply436,11486
-pub struct SetDrillPendingEdit {SetDrillPendingEdit492,13635
-    pub record_idx: usize,record_idx493,13668
-    pub col_name: String,col_name494,13695
-    pub new_value: String,new_value495,13721
-impl Effect for SetDrillPendingEdit {SetDrillPendingEdit497,13750
-    fn apply(&self, app: &mut App) {apply498,13788
-pub struct Save;Save511,14274
-impl Effect for Save {Save512,14291
-    fn apply(&self, app: &mut App) {apply513,14314
-pub struct SaveAs(pub PathBuf);SaveAs531,14877
-impl Effect for SaveAs {SaveAs532,14909
-    fn apply(&self, app: &mut App) {apply533,14934
-pub struct WizardKey {WizardKey551,15548
-    pub key_code: crossterm::event::KeyCode,key_code552,15571
-impl Effect for WizardKey {WizardKey554,15618
-    fn apply(&self, app: &mut App) {apply555,15646
-pub struct StartImportWizard(pub String);StartImportWizard681,21286
-impl Effect for StartImportWizard {StartImportWizard682,21328
-    fn apply(&self, app: &mut App) {apply683,21364
-pub struct ExportCsv(pub PathBuf);ExportCsv702,21999
-impl Effect for ExportCsv {ExportCsv703,22034
-    fn apply(&self, app: &mut App) {apply704,22062
-pub struct LoadModel(pub PathBuf);LoadModel719,22544
-impl Effect for LoadModel {LoadModel720,22579
-    fn apply(&self, app: &mut App) {apply721,22607
-pub struct ImportJsonHeadless {ImportJsonHeadless737,23116
-    pub path: PathBuf,path738,23148
-    pub model_name: Option<String>,model_name739,23171
-    pub array_path: Option<String>,array_path740,23207
-impl Effect for ImportJsonHeadless {ImportJsonHeadless742,23245
-    fn apply(&self, app: &mut App) {apply743,23282
-pub struct SetPanelOpen {SetPanelOpen847,26844
-    pub panel: Panel,panel848,26870
-    pub open: bool,open849,26892
-pub enum Panel {Panel853,26945
-    Formula,Formula854,26962
-    Category,Category855,26975
-    View,View856,26989
-impl Panel {Panel859,27002
-    pub fn mode(self) -> AppMode {mode860,27015
-impl Effect for SetPanelOpen {SetPanelOpen869,27245
-    fn apply(&self, app: &mut App) {apply870,27276
-pub struct SetPanelCursor {SetPanelCursor880,27570
-    pub panel: Panel,panel881,27598
-    pub cursor: usize,cursor882,27620
-impl Effect for SetPanelCursor {SetPanelCursor884,27645
-    fn apply(&self, app: &mut App) {apply885,27678
-pub fn mark_dirty() -> Box<dyn Effect> {mark_dirty896,28140
-pub fn set_status(msg: impl Into<String>) -> Box<dyn Effect> {set_status900,28208
-pub fn change_mode(mode: AppMode) -> Box<dyn Effect> {change_mode904,28310
-pub fn set_selected(row: usize, col: usize) -> Box<dyn Effect> {set_selected908,28399
-pub struct HelpPageNext;HelpPageNext915,28709
-impl Effect for HelpPageNext {HelpPageNext916,28734
-    fn apply(&self, app: &mut App) {apply917,28765
-pub struct HelpPagePrev;HelpPagePrev924,28964
-impl Effect for HelpPagePrev {HelpPagePrev925,28989
-    fn apply(&self, app: &mut App) {apply926,29020
-pub struct HelpPageSet(pub usize);HelpPageSet932,29140
-impl Effect for HelpPageSet {HelpPageSet933,29175
-    fn apply(&self, app: &mut App) {apply934,29205
-pub fn help_page_next() -> Box<dyn Effect> {help_page_next939,29283
-pub fn help_page_prev() -> Box<dyn Effect> {help_page_prev943,29358
-pub fn help_page_set(page: usize) -> Box<dyn Effect> {help_page_set947,29433
-mod tests {tests952,29536
-    fn test_app() -> App {test_app957,29646
-    fn add_category_effect() {add_category_effect971,30242
-    fn add_item_to_existing_category() {add_item_to_existing_category978,30442
-    fn add_item_to_nonexistent_category_sets_status() {add_item_to_nonexistent_category_sets_status996,30915
-    fn set_cell_and_clear_cell() {set_cell_and_clear_cell1007,31224
-    fn add_formula_valid() {add_formula_valid1021,31699
-    fn add_formula_adds_target_item_to_category() {add_formula_adds_target_item_to_category1035,32231
-    fn add_formula_to_measure_shows_in_effective_items() {add_formula_to_measure_shows_in_effective_items1067,33271
-    fn add_formula_invalid_sets_error_status() {add_formula_invalid_sets_error_status1093,34203
-    fn remove_formula_effect() {remove_formula_effect1104,34520
-    fn switch_view_pushes_to_back_stack() {switch_view_pushes_to_back_stack1123,35203
-    fn switch_view_to_same_does_not_push_stack() {switch_view_to_same_does_not_push_stack1136,35676
-    fn view_back_and_forward() {view_back_and_forward1143,35888
-    fn view_back_with_empty_stack_is_noop() {view_back_with_empty_stack_is_noop1163,36617
-    fn create_and_delete_view() {create_and_delete_view1171,36853
-    fn set_axis_effect() {set_axis_effect1181,37172
-    fn transpose_axes_effect() {transpose_axes_effect1192,37451
-    fn set_selected_effect() {set_selected_effect1230,38663
-    fn set_row_and_col_offset() {set_row_and_col_offset1237,38852
-    fn change_mode_effect() {change_mode_effect1248,39316
-    fn set_buffer_empty_clears() {set_buffer_empty_clears1258,39680
-    fn set_status_effect() {set_status_effect1271,40066
-    fn mark_dirty_effect() {mark_dirty_effect1278,40249
-    fn set_yanked_effect() {set_yanked_effect1286,40423
-    fn set_search_query_and_mode() {set_search_query_and_mode1293,40634
-    fn set_buffer_normal_key() {set_buffer_normal_key1306,41145
-    fn set_buffer_search_writes_to_search_query() {set_buffer_search_writes_to_search_query1317,41428
-    fn set_panel_open_and_cursor() {set_panel_open_and_cursor1331,41968
-    fn set_tile_cat_idx_effect() {set_tile_cat_idx_effect1363,42696
-    fn help_page_navigation() {help_page_navigation1372,43042
-    fn help_page_prev_clamps_at_zero() {help_page_prev_clamps_at_zero1386,43471
-    fn start_drill_and_apply_clear_drill_with_no_edits() {start_drill_and_apply_clear_drill_with_no_edits1395,43824
-    fn apply_and_clear_drill_with_value_edit() {apply_and_clear_drill_with_value_edit1412,44433
-    fn apply_and_clear_drill_with_coord_rename() {apply_and_clear_drill_with_coord_rename1439,45312
-    fn apply_and_clear_drill_empty_value_clears_cell() {apply_and_clear_drill_empty_value_clears_cell1480,46669
-    fn toggle_prune_empty_effect() {toggle_prune_empty_effect1506,47610
-    fn toggle_cat_expand_effect() {toggle_cat_expand_effect1516,47972
-    fn remove_item_and_category() {remove_item_and_category1526,48344
-    fn set_number_format_effect() {set_number_format_effect1549,49103
-    fn set_page_selection_effect() {set_page_selection_effect1558,49501
-    fn hide_and_show_item_effects() {hide_and_show_item_effects1571,49995
-    fn toggle_group_effect() {toggle_group_effect1591,50679
-    fn cycle_axis_effect() {cycle_axis_effect1618,51509
-    fn save_without_file_path_shows_status() {save_without_file_path_shows_status1629,51969
-    fn panel_mode_mapping() {panel_mode_mapping1638,52332
+src/ui/effect.rs,14353
+pub(crate) const RECORD_COORDS_CANNOT_BE_EMPTY: &str = "Record coordinates cannot be empty";RECORD_COORDS_CANNOT_BE_EMPTY9,160
+pub trait Effect: Debug {Effect13,358
+    fn apply(&self, app: &mut App);apply14,384
+    fn changes_mode(&self) -> bool {changes_mode16,470
+pub struct AddCategory(pub String);AddCategory24,749
+impl Effect for AddCategory {AddCategory25,785
+    fn apply(&self, app: &mut App) {apply26,815
+pub struct AddItem {AddItem32,927
+    pub category: String,category33,948
+    pub item: String,item34,974
+impl Effect for AddItem {AddItem36,998
+    fn apply(&self, app: &mut App) {apply37,1024
+pub struct AddItemInGroup {AddItemInGroup47,1298
+    pub category: String,category48,1326
+    pub item: String,item49,1352
+    pub group: String,group50,1374
+impl Effect for AddItemInGroup {AddItemInGroup52,1399
+    fn apply(&self, app: &mut App) {apply53,1432
+pub struct SortData;SortData63,1728
+impl Effect for SortData {SortData64,1749
+    fn apply(&self, app: &mut App) {apply65,1776
+pub struct SetCell(pub CellKey, pub CellValue);SetCell71,1877
+impl Effect for SetCell {SetCell72,1925
+    fn apply(&self, app: &mut App) {apply73,1951
+pub struct ClearCell(pub CellKey);ClearCell79,2074
+impl Effect for ClearCell {ClearCell80,2109
+    fn apply(&self, app: &mut App) {apply81,2137
+pub struct AddFormula {AddFormula87,2239
+    pub raw: String,raw88,2263
+    pub target_category: String,target_category89,2284
+impl Effect for AddFormula {AddFormula91,2319
+    fn apply(&self, app: &mut App) {apply92,2348
+pub struct RemoveFormula {RemoveFormula113,3140
+    pub target: String,target114,3167
+    pub target_category: String,target_category115,3191
+impl Effect for RemoveFormula {RemoveFormula117,3226
+    fn apply(&self, app: &mut App) {apply118,3258
+pub struct EnterEditAtCursor {EnterEditAtCursor132,3792
+    pub target_mode: AppMode,target_mode133,3823
+impl Effect for EnterEditAtCursor {EnterEditAtCursor135,3855
+    fn apply(&self, app: &mut App) {apply136,3891
+pub struct TogglePruneEmpty;TogglePruneEmpty152,4444
+impl Effect for TogglePruneEmpty {TogglePruneEmpty153,4473
+    fn apply(&self, app: &mut App) {apply154,4508
+pub struct ToggleCatExpand(pub String);ToggleCatExpand161,4656
+impl Effect for ToggleCatExpand {ToggleCatExpand162,4696
+    fn apply(&self, app: &mut App) {apply163,4730
+pub struct RemoveItem {RemoveItem171,4905
+    pub category: String,category172,4929
+    pub item: String,item173,4955
+impl Effect for RemoveItem {RemoveItem175,4979
+    fn apply(&self, app: &mut App) {apply176,5008
+pub struct RemoveCategory(pub String);RemoveCategory182,5130
+impl Effect for RemoveCategory {RemoveCategory183,5169
+    fn apply(&self, app: &mut App) {apply184,5202
+pub struct CreateView(pub String);CreateView192,5513
+impl Effect for CreateView {CreateView193,5548
+    fn apply(&self, app: &mut App) {apply194,5577
+pub struct DeleteView(pub String);DeleteView200,5680
+impl Effect for DeleteView {DeleteView201,5715
+    fn apply(&self, app: &mut App) {apply202,5744
+pub struct SwitchView(pub String);SwitchView208,5855
+impl Effect for SwitchView {SwitchView209,5890
+    fn apply(&self, app: &mut App) {apply210,5919
+pub struct ViewBack;ViewBack225,6386
+impl Effect for ViewBack {ViewBack226,6407
+    fn apply(&self, app: &mut App) {apply227,6434
+pub struct ViewForward;ViewForward242,6941
+impl Effect for ViewForward {ViewForward243,6965
+    fn apply(&self, app: &mut App) {apply244,6995
+pub struct SetAxis {SetAxis258,7422
+    pub category: String,category259,7443
+    pub axis: Axis,axis260,7469
+impl Effect for SetAxis {SetAxis262,7491
+    fn apply(&self, app: &mut App) {apply263,7517
+pub struct SetPageSelection {SetPageSelection271,7679
+    pub category: String,category272,7709
+    pub item: String,item273,7735
+impl Effect for SetPageSelection {SetPageSelection275,7759
+    fn apply(&self, app: &mut App) {apply276,7794
+pub struct ToggleGroup {ToggleGroup284,7967
+    pub category: String,category285,7992
+    pub group: String,group286,8018
+impl Effect for ToggleGroup {ToggleGroup288,8043
+    fn apply(&self, app: &mut App) {apply289,8073
+pub struct HideItem {HideItem297,8250
+    pub category: String,category298,8272
+    pub item: String,item299,8298
+impl Effect for HideItem {HideItem301,8322
+    fn apply(&self, app: &mut App) {apply302,8349
+pub struct ShowItem {ShowItem310,8513
+    pub category: String,category311,8535
+    pub item: String,item312,8561
+impl Effect for ShowItem {ShowItem314,8585
+    fn apply(&self, app: &mut App) {apply315,8612
+pub struct TransposeAxes;TransposeAxes323,8776
+impl Effect for TransposeAxes {TransposeAxes324,8802
+    fn apply(&self, app: &mut App) {apply325,8834
+pub struct CycleAxis(pub String);CycleAxis331,8951
+impl Effect for CycleAxis {CycleAxis332,8985
+    fn apply(&self, app: &mut App) {apply333,9013
+pub struct SetNumberFormat(pub String);SetNumberFormat339,9133
+impl Effect for SetNumberFormat {SetNumberFormat340,9173
+    fn apply(&self, app: &mut App) {apply341,9207
+pub struct SetSelected(pub usize, pub usize);SetSelected349,9550
+impl Effect for SetSelected {SetSelected350,9596
+    fn apply(&self, app: &mut App) {apply351,9626
+pub struct SetRowOffset(pub usize);SetRowOffset357,9754
+impl Effect for SetRowOffset {SetRowOffset358,9790
+    fn apply(&self, app: &mut App) {apply359,9821
+pub struct SetColOffset(pub usize);SetColOffset365,9941
+impl Effect for SetColOffset {SetColOffset366,9977
+    fn apply(&self, app: &mut App) {apply367,10008
+pub struct ChangeMode(pub AppMode);ChangeMode375,10342
+impl Effect for ChangeMode {ChangeMode376,10378
+    fn apply(&self, app: &mut App) {apply377,10407
+    fn changes_mode(&self) -> bool {changes_mode380,10485
+pub struct SetStatus(pub String);SetStatus386,10561
+impl Effect for SetStatus {SetStatus387,10595
+    fn apply(&self, app: &mut App) {apply388,10623
+pub struct MarkDirty;MarkDirty394,10727
+impl Effect for MarkDirty {MarkDirty395,10749
+    fn apply(&self, app: &mut App) {apply396,10777
+pub struct SetYanked(pub Option<CellValue>);SetYanked402,10866
+impl Effect for SetYanked {SetYanked403,10911
+    fn apply(&self, app: &mut App) {apply404,10939
+pub struct SetSearchQuery(pub String);SetSearchQuery410,11039
+impl Effect for SetSearchQuery {SetSearchQuery411,11078
+    fn apply(&self, app: &mut App) {apply412,11111
+pub struct SetSearchMode(pub bool);SetSearchMode418,11217
+impl Effect for SetSearchMode {SetSearchMode419,11253
+    fn apply(&self, app: &mut App) {apply420,11285
+pub struct SetBuffer {SetBuffer427,11417
+    pub name: String,name428,11440
+    pub value: String,value429,11462
+impl Effect for SetBuffer {SetBuffer431,11487
+    fn apply(&self, app: &mut App) {apply432,11515
+pub struct SetTileCatIdx(pub usize);SetTileCatIdx443,11843
+impl Effect for SetTileCatIdx {SetTileCatIdx444,11880
+    fn apply(&self, app: &mut App) {apply445,11912
+pub struct StartDrill(pub Vec<(CellKey, CellValue)>);StartDrill453,12111
+impl Effect for StartDrill {StartDrill454,12165
+    fn apply(&self, app: &mut App) {apply455,12194
+pub struct ApplyAndClearDrill;ApplyAndClearDrill465,12509
+impl Effect for ApplyAndClearDrill {ApplyAndClearDrill466,12540
+    fn apply(&self, app: &mut App) {apply467,12577
+pub struct SetDrillPendingEdit {SetDrillPendingEdit527,14896
+    pub record_idx: usize,record_idx528,14929
+    pub col_name: String,col_name529,14956
+    pub new_value: String,new_value530,14982
+impl Effect for SetDrillPendingEdit {SetDrillPendingEdit532,15011
+    fn apply(&self, app: &mut App) {apply533,15049
+pub struct Save;Save546,15535
+impl Effect for Save {Save547,15552
+    fn apply(&self, app: &mut App) {apply548,15575
+pub struct SaveAs(pub PathBuf);SaveAs566,16138
+impl Effect for SaveAs {SaveAs567,16170
+    fn apply(&self, app: &mut App) {apply568,16195
+pub struct WizardKey {WizardKey586,16809
+    pub key_code: crossterm::event::KeyCode,key_code587,16832
+impl Effect for WizardKey {WizardKey589,16879
+    fn apply(&self, app: &mut App) {apply590,16907
+pub struct StartImportWizard(pub String);StartImportWizard716,22547
+impl Effect for StartImportWizard {StartImportWizard717,22589
+    fn apply(&self, app: &mut App) {apply718,22625
+pub struct ExportCsv(pub PathBuf);ExportCsv737,23260
+impl Effect for ExportCsv {ExportCsv738,23295
+    fn apply(&self, app: &mut App) {apply739,23323
+pub struct LoadModel(pub PathBuf);LoadModel754,23805
+impl Effect for LoadModel {LoadModel755,23840
+    fn apply(&self, app: &mut App) {apply756,23868
+pub struct ImportJsonHeadless {ImportJsonHeadless772,24377
+    pub path: PathBuf,path773,24409
+    pub model_name: Option<String>,model_name774,24432
+    pub array_path: Option<String>,array_path775,24468
+impl Effect for ImportJsonHeadless {ImportJsonHeadless777,24506
+    fn apply(&self, app: &mut App) {apply778,24543
+pub struct SetPanelOpen {SetPanelOpen882,28105
+    pub panel: Panel,panel883,28131
+    pub open: bool,open884,28153
+pub enum Panel {Panel888,28206
+    Formula,Formula889,28223
+    Category,Category890,28236
+    View,View891,28250
+impl Panel {Panel894,28263
+    pub fn mode(self) -> AppMode {mode895,28276
+impl Effect for SetPanelOpen {SetPanelOpen904,28506
+    fn apply(&self, app: &mut App) {apply905,28537
+pub struct SetPanelCursor {SetPanelCursor915,28831
+    pub panel: Panel,panel916,28859
+    pub cursor: usize,cursor917,28881
+impl Effect for SetPanelCursor {SetPanelCursor919,28906
+    fn apply(&self, app: &mut App) {apply920,28939
+pub fn mark_dirty() -> Box<dyn Effect> {mark_dirty931,29401
+pub fn set_status(msg: impl Into<String>) -> Box<dyn Effect> {set_status935,29469
+pub fn change_mode(mode: AppMode) -> Box<dyn Effect> {change_mode939,29571
+pub fn set_selected(row: usize, col: usize) -> Box<dyn Effect> {set_selected943,29660
+pub struct HelpPageNext;HelpPageNext950,29970
+impl Effect for HelpPageNext {HelpPageNext951,29995
+    fn apply(&self, app: &mut App) {apply952,30026
+pub struct HelpPagePrev;HelpPagePrev959,30225
+impl Effect for HelpPagePrev {HelpPagePrev960,30250
+    fn apply(&self, app: &mut App) {apply961,30281
+pub struct HelpPageSet(pub usize);HelpPageSet967,30401
+impl Effect for HelpPageSet {HelpPageSet968,30436
+    fn apply(&self, app: &mut App) {apply969,30466
+pub fn help_page_next() -> Box<dyn Effect> {help_page_next974,30544
+pub fn help_page_prev() -> Box<dyn Effect> {help_page_prev978,30619
+pub fn help_page_set(page: usize) -> Box<dyn Effect> {help_page_set982,30694
+mod tests {tests987,30797
+    fn test_app() -> App {test_app992,30907
+    fn add_category_effect() {add_category_effect1006,31503
+    fn add_item_to_existing_category() {add_item_to_existing_category1013,31703
+    fn add_item_to_nonexistent_category_sets_status() {add_item_to_nonexistent_category_sets_status1031,32176
+    fn set_cell_and_clear_cell() {set_cell_and_clear_cell1042,32485
+    fn add_formula_valid() {add_formula_valid1056,32960
+    fn add_formula_adds_target_item_to_category() {add_formula_adds_target_item_to_category1070,33492
+    fn add_formula_to_measure_shows_in_effective_items() {add_formula_to_measure_shows_in_effective_items1102,34532
+    fn add_formula_invalid_sets_error_status() {add_formula_invalid_sets_error_status1128,35464
+    fn remove_formula_effect() {remove_formula_effect1139,35781
+    fn switch_view_pushes_to_back_stack() {switch_view_pushes_to_back_stack1158,36464
+    fn switch_view_to_same_does_not_push_stack() {switch_view_to_same_does_not_push_stack1171,36939
+    fn view_back_and_forward() {view_back_and_forward1178,37151
+    fn view_back_with_empty_stack_is_noop() {view_back_with_empty_stack_is_noop1200,37973
+    fn create_and_delete_view() {create_and_delete_view1208,38209
+    fn set_axis_effect() {set_axis_effect1218,38528
+    fn transpose_axes_effect() {transpose_axes_effect1229,38807
+    fn set_selected_effect() {set_selected_effect1267,40019
+    fn set_row_and_col_offset() {set_row_and_col_offset1274,40208
+    fn change_mode_effect() {change_mode_effect1285,40672
+    fn enter_edit_at_cursor_uses_target_mode_not_app_mode() {enter_edit_at_cursor_uses_target_mode_not_app_mode1297,41189
+    fn set_buffer_empty_clears() {set_buffer_empty_clears1330,42352
+    fn set_status_effect() {set_status_effect1343,42738
+    fn mark_dirty_effect() {mark_dirty_effect1350,42921
+    fn set_yanked_effect() {set_yanked_effect1358,43095
+    fn set_search_query_and_mode() {set_search_query_and_mode1365,43306
+    fn set_buffer_normal_key() {set_buffer_normal_key1378,43817
+    fn set_buffer_search_writes_to_search_query() {set_buffer_search_writes_to_search_query1389,44100
+    fn set_panel_open_and_cursor() {set_panel_open_and_cursor1403,44640
+    fn set_tile_cat_idx_effect() {set_tile_cat_idx_effect1435,45368
+    fn help_page_navigation() {help_page_navigation1444,45714
+    fn help_page_prev_clamps_at_zero() {help_page_prev_clamps_at_zero1458,46143
+    fn start_drill_and_apply_clear_drill_with_no_edits() {start_drill_and_apply_clear_drill_with_no_edits1467,46496
+    fn apply_and_clear_drill_with_value_edit() {apply_and_clear_drill_with_value_edit1484,47105
+    fn apply_and_clear_drill_with_coord_rename() {apply_and_clear_drill_with_coord_rename1511,47984
+    fn apply_and_clear_drill_empty_value_clears_cell() {apply_and_clear_drill_empty_value_clears_cell1552,49341
+    fn toggle_prune_empty_effect() {toggle_prune_empty_effect1578,50282
+    fn toggle_cat_expand_effect() {toggle_cat_expand_effect1588,50644
+    fn remove_item_and_category() {remove_item_and_category1598,51016
+    fn set_number_format_effect() {set_number_format_effect1621,51775
+    fn set_page_selection_effect() {set_page_selection_effect1630,52173
+    fn hide_and_show_item_effects() {hide_and_show_item_effects1643,52667
+    fn toggle_group_effect() {toggle_group_effect1663,53351
+    fn cycle_axis_effect() {cycle_axis_effect1690,54181
+    fn save_without_file_path_shows_status() {save_without_file_path_shows_status1701,54641
+    fn panel_mode_mapping() {panel_mode_mapping1710,55004
 
 src/ui/mod.rs,400
 pub mod app;app1,0
